//+------------------------------------------------------------------+
//|                                   Double Smoothed Stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red//Brown
#property indicator_color3  Orange
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_width1  2
#property indicator_width2  2

extern int StochasticPeriod = 14;//55;
extern int EMAPeriod        = 4;//15;
double upBuffera[];
double dnBuffera[];
double dnBufferb[];
double wrBuffera[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, upBuffera);
   SetIndexBuffer(1, dnBuffera);
   SetIndexBuffer(2, dnBufferb);
   SetIndexBuffer(3, wrBuffera);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
      IndicatorShortName("DSS");//("Double smoothed stochastic "+StochasticPeriod+","+EMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double max,min,sto;
   double alpha = 2.0/(1.0+EMAPeriod);
   int    counted_bars=IndicatorCounted();
   int    i,limit;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars - counted_bars,Bars-1);

      if (upBuffera[limit] < upBuffera[limit+1]) CleanPoint(limit,dnBuffera,dnBufferb);
         
      for(i = limit; i >= 0 ; i--)
      {
         max = High[ArrayMaximum(High,StochasticPeriod,i)];
         min =  Low[ArrayMinimum( Low,StochasticPeriod,i)];
         if (max!=min)
               sto = (Close[i]-min)/(max-min)*100.00;
         else  sto = 0;            
         wrBuffera[i] = wrBuffera[i+1]+alpha*(sto-wrBuffera[i+1]);
           
         max = wrBuffera[ArrayMaximum(wrBuffera,StochasticPeriod,i)];
         min = wrBuffera[ArrayMinimum(wrBuffera,StochasticPeriod,i)];
         if (max!=min)
               sto = (wrBuffera[i]-min)/(max-min)*100.00;
         else  sto = 0;            
         upBuffera[i] = upBuffera[i+1]+alpha*(sto-upBuffera[i+1]);

         dnBuffera[i] = EMPTY_VALUE;
         dnBufferb[i] = EMPTY_VALUE;
            if (upBuffera[i] < upBuffera[i+1]) PlotPoint(i,dnBuffera,dnBufferb,upBuffera);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

